VERSION 5.00
Begin VB.Form frmEventTypes 
   Caption         =   "Select Event Types"
   ClientHeight    =   3720
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8145
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3720
   ScaleWidth      =   8145
   Begin VB.CommandButton cmdClearSome 
      Caption         =   "<"
      Height          =   495
      Left            =   3840
      TabIndex        =   7
      Top             =   1800
      Width           =   495
   End
   Begin VB.CommandButton cmdSelectSome 
      Caption         =   ">"
      Height          =   495
      Left            =   3840
      TabIndex        =   6
      Top             =   1200
      Width           =   495
   End
   Begin VB.ListBox lstInclude 
      Height          =   2400
      Left            =   4440
      MultiSelect     =   2  'Extended
      TabIndex        =   5
      Top             =   600
      Width           =   3495
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "<<"
      Height          =   495
      Left            =   3840
      TabIndex        =   4
      Top             =   2400
      Width           =   495
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   ">>"
      Height          =   495
      Left            =   3840
      TabIndex        =   3
      Top             =   600
      Width           =   495
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   495
      Left            =   3480
      TabIndex        =   2
      Top             =   3120
      Width           =   1215
   End
   Begin VB.ListBox lstExclude 
      Height          =   2400
      Left            =   240
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   600
      Width           =   3495
   End
   Begin VB.Label Label2 
      Caption         =   "Show These Event Types"
      Height          =   255
      Left            =   4440
      TabIndex        =   9
      Top             =   360
      Width           =   3495
   End
   Begin VB.Label Label1 
      Caption         =   "Don't Show These Event Types"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   360
      Width           =   3135
   End
   Begin VB.Label lblHelp 
      Alignment       =   2  'Center
      Caption         =   "Select Event Types For Calendar, then click 'Done'"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   8175
   End
End
Attribute VB_Name = "frmEventTypes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim FirstTime As Boolean

Private Sub cmdClear_Click()
    init_form
End Sub

Private Sub cmdClearSome_Click()
    Dim i As Integer
    Dim SelectedEvents(MaxEvents) As Integer
    Dim NumSelected As Integer
    Dim ndx As Integer
    
    ' build list of items to be removed
    For i = 0 To lstInclude.ListCount - 1
        If lstInclude.Selected(i) Then
            ' selected - add to list
            SelectedEvents(NumSelected) = i
            NumSelected = NumSelected + 1
        End If
    Next
    
    ' move selected items from include to exclude
    For i = 0 To NumSelected - 1
        ndx = SelectedEvents(i)
        lstExclude.AddItem lstInclude.List(ndx - i)
        lstExclude.ItemData(lstExclude.NewIndex) = lstInclude.ItemData(ndx - i)
        lstInclude.RemoveItem (ndx - i)
    Next

End Sub

Private Sub cmdDone_Click()
    load_event_types
    Unload Me
End Sub
Sub load_event_types()
    NumEventTypes = 0   ' clear list of event types
    If lstInclude.ListCount = 0 Then
        Exit Sub
    End If
    
    ' something selected - save list
    Dim ndx As Long
    Dim s As String
    Dim loc As Long

    For ndx = 0 To lstInclude.ListCount - 1
        s = lstInclude.List(ndx)
        loc = InStr(s, vbTab)
        If loc >= 0 Then
            s = Left(s, loc - 1)
        End If
        EventTypes(NumEventTypes) = s
        NumEventTypes = NumEventTypes + 1
    Next

End Sub

Private Sub cmdSelect_Click()
    Dim ndx As Long
    
    ' move all events from exclude to include
    Do While lstExclude.ListCount > 0
        lstInclude.AddItem lstExclude.List(0)
        lstInclude.ItemData(0) = lstExclude.ItemData(0)
        lstExclude.RemoveItem (0)
    Loop
End Sub

Private Sub cmdSelectSome_Click()
    Dim i As Integer
    Dim SelectedEvents(MaxEvents)
    Dim NumSelected As Integer
    Dim ndx As Integer
    
    ' build list of selected items
    For i = 0 To lstExclude.ListCount - 1
        If lstExclude.Selected(i) Then
            SelectedEvents(NumSelected) = i
            NumSelected = NumSelected + 1
        End If
    Next
    
    ' move all selected items to include
    For i = 0 To NumSelected - 1
        ndx = SelectedEvents(i)
        lstInclude.AddItem lstExclude.List(ndx - i)
        lstInclude.ItemData(lstInclude.NewIndex) = lstExclude.ItemData(ndx - i)
        lstExclude.RemoveItem (ndx - i)
    Next

End Sub

Private Sub Form_Activate()
    If FirstTime Then
        init_form
        FirstTime = False
    End If
End Sub

Private Sub Form_Load()
    FirstTime = True
    Me.Width = mdiStakeCal.Width - 500
    Me.Height = mdiStakeCal.Height - 1000
End Sub
Sub init_form()
    Dim s As String
    Dim rsCal As ADODB.Recordset

    lstInclude.Clear
    lstExclude.Clear

    s = "select * from EventTypes order by TypeDesc"
    Set rsCal = New ADODB.Recordset
    rsCal.Open s, dbConnection, , , adCmdText
    
    Do While Not rsCal.EOF
        s = rsCal("TypeCode") & vbTab & rsCal("TypeDesc")
        lstExclude.AddItem s
        rsCal.MoveNext
    Loop
    rsCal.Close
    Set rsCal = Nothing
End Sub
